/* Copyright 2018 Eucalyn
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#pragma once

#include "quantum.h"

// This a shortcut to help you visually see your layout.
// The following is an example using the Planck MIT layout
// The first section contains all of the arguments
// The second converts the arguments into a two-dimensional array
#define LAYOUT( \
    L00, L01, L02, L03, L04, L05, L06, L07,      R00, R01, R02, R03, R04, R05, R06, R07, R08, R09, \
    L10, L11, L12, L13, L14, L15, L16, L17,      R10, R11, R12, R13, R14, R15, R16, R17, R18, R19, \
    L20, L21, L22, L23, L24, L25, L26, L27,      R20, R21, R22, R23, R24, R25, R26, R27, R28, R29, \
    L30, L31, L32, L33, L34, L35, L36, L37,      R30, R31, R32, R33, R34, R35, R36, R37, R38, R39, \
    L40, L41, L42, L43, L44, L45, L46, L47,      R40, R41, R42, R43, R44, R45, R46, R47, R48, R49, \
    L50, L51, L52, L53, L54, L55, L56, L57,      R50, R51, R52, R53, R54, R55, R56, R57, R58, R59 \
  ) \
  \
  { \
  { L07   , L06   , L05   , L04   , L03   , L02   , L01   , L00  }  , \
  { KC_NO , KC_NO , L15   , L14   , L13   , L12   , L11   , L10  } , \
  { KC_NO , L26   , L25   , L24   , L23   , L22   , L21   , L20  } , \
  { L37   , L36   , L35   , L34   , L33   , L32   , L31   , L30  } , \
  { L47   , L46   , L45   , L44   , L43   , L42   , L41   , L40  } , \
  { KC_NO , KC_NO , L55   , L54   , L53   , L52   , KC_NO , L50  } , \
\
  { R00   , R01   , R02   , R03   , R04   , R05   , R06   , R07 , R08   , R09 }     , \
  { R10   , R11   , R12   , R13   , R14   , R15   , R16   , R17 , R18   , R19 }     , \
  { KC_NO , R21   , R22   , R23   , R24   , R25   , R26   , R27 , R28   , R29 }     , \
  { R30   , R31   , R32   , R33   , R34   , R35   , R36   , R37 , R38   , R39 }     , \
  { R40   , R41   , R42   , R43   , R44   , R45   , R46   , R47 , R48   , R49 }     , \
  { KC_NO , KC_NO , R52   , R53   , R54   , R55   , KC_NO , R57 , KC_NO , R59 }   \
  }

