/* Copyright 2018 Eucalyn
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#define MACRO1_STRINGS ""
#define MACRO2_STRINGS ""
#define MACRO3_STRINGS ""
#define	MACRO4_STRINGS ""
#define MACRO5_STRINGS ""

#include QMK_KEYBOARD_H
#include "keymap_jp.h"

enum custom_keycodes {
  LT2_MHEN = SAFE_RANGE,
  LT2_HENK,
  CTL_ESC, 
  CTL_APP, 
  ALT_KANA, 
  SFT_SPC, 
  C_S_ESP, 
  ALT_F4, 
  TT_TEN,
  TT_FUNC,
  NEXTWIN, 
  MS_BTN1,
  MS_BTN2,
  MS_D1,
  CLICK_REV,
  KC_00,
  MACRO1,
  MACRO2,
  MACRO3,
  MACRO4,
  MACRO5,
};

enum layer_number {
  _QWERTY = 0,
  _NODOKA,
  _FUNCTION,
  _TENKEY,
  _HENKAN,
  _TEMPLATE,
};

#define MO_FUNC   MO(_FUNCTION) 
#define TG_TEN   TG(_TENKEY) 
/* #define TG_FUNC  TG(_FUNCTION)  */
#define TG_NODOKA TG(_NODOKA)

const uint16_t PROGMEM keymaps[][MATRIX_ROWS][MATRIX_COLS] = {
  [_QWERTY] = LAYOUT( \
  KC_ESC  , KC_PSCR , KC_SLCK , KC_PAUSE, KC_F1   , KC_F2   , KC_F3   , KC_F4   , KC_F5   , KC_F6   , KC_F7   , KC_F8   , KC_F9   , KC_F10  , KC_INS  , KC_HOME , KC_END  , KC_BSPC   , \
  KC_ZKHK , KC_1    , KC_2    , KC_3    , KC_4    , KC_5    , XXXXXXX , XXXXXXX , KC_F11  , KC_F12  , KC_6    , KC_7    , KC_8    , KC_9    , KC_0    , JP_MINS , JP_CIRC , JP_YEN    , \
  KC_TAB  , KC_Q    , KC_W    , KC_E    , KC_R    , KC_T    , KC_DOWN , XXXXXXX , XXXXXXX , KC_UP   , KC_Y    , KC_U    , KC_I    , KC_O    , KC_P    , JP_AT   , JP_LBRC , KC_ENT    , \
  KC_CAPS , KC_A    , KC_S    , KC_D    , KC_F    , KC_G    , KC_WH_U , KC_LEFT , KC_RGHT , MS_BTN2 , KC_H    , KC_J    , KC_K    , KC_L    , JP_SCLN , JP_COLN , JP_RBRC , KC_PGUP   , \
  KC_LSFT , KC_Z    , KC_X    , KC_C    , KC_V    , KC_B    , TT_TEN  , KC_WH_D , MS_BTN1 , TT_TEN  , KC_N    , KC_M    , KC_COMM , KC_DOT  , KC_SLSH , JP_BSLS , KC_RSFT , KC_PGDN   , \
  KC_LCTL , XXXXXXX , KC_LGUI , KC_LALT , KC_MHEN , KC_SPC  , XXXXXXX , XXXXXXX , XXXXXXX , XXXXXXX , KC_SPC  , KC_HENK , KC_KANA , MO_FUNC , XXXXXXX , KC_APP  , XXXXXXX , KC_DEL \
  )       ,
  [_NODOKA] = LAYOUT( \
  _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______   , \
  _______ , _______ , _______ , _______ , _______ , _______ , XXXXXXX , XXXXXXX , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______   , \
  _______ , _______ , _______ , _______ , _______ , _______ , _______ , XXXXXXX , XXXXXXX , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______   , \
  _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______   , \
  _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______   , \
  CTL_ESC , XXXXXXX , _______ , _______ , LT2_MHEN, SFT_SPC , XXXXXXX , _______ , _______ , XXXXXXX , SFT_SPC , LT2_HENK, ALT_KANA, _______ , XXXXXXX , CTL_APP , XXXXXXX , _______ \
  )       ,
  [_HENKAN] = LAYOUT( \
  _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______   , \
  _______ , KC_F1   , KC_F2   , KC_F3   , KC_F4   , KC_F5   , XXXXXXX , XXXXXXX , _______ , _______ , KC_F6   , KC_F7   , KC_F8   , KC_F9   , KC_F10  , KC_F11  , KC_F12  , _______   , \
  _______ , KC_1    , KC_2    , KC_3    , KC_4    , KC_5    , _______ , XXXXXXX , XXXXXXX , _______ , KC_6    , KC_7    , KC_8    , KC_9    , KC_0    , JP_MINS , JP_CIRC , JP_YEN    , \
  _______ , C_S_ESP , NEXTWIN , KC_INS  , ALT_F4  , KC_END  , _______ , _______ , _______ , _______ , KC_LEFT , KC_DOWN , KC_UP   , KC_RGHT , KC_PGDN , KC_PGUP , _______ , _______   , \
  _______ , _______ , _______ , _______ , _______ , KC_HOME , _______ , _______ , _______ , _______ , KC_BSPC , KC_DEL  , _______ , _______ , _______ , _______ , _______ , _______   , \
  _______ , XXXXXXX , _______ , _______ , _______ , _______ , XXXXXXX , XXXXXXX , XXXXXXX , XXXXXXX , _______ , _______ , XXXXXXX , _______ , XXXXXXX , _______ , XXXXXXX , _______\
  )       ,
  /* [_FUNCTION] = LAYOUT( \ */
  /* _______ , _______ , XXXXXXX , XXXXXXX , XXXXXXX , XXXXXXX , XXXXXXX , XXXXXXX , XXXXXXX , XXXXXXX , XXXXXXX , XXXXXXX , XXXXXXX , XXXXXXX , _______ , _______ , _______ , _______  , \ */
  /* _______ , _______ , _______ , _______ , _______ , _______ , XXXXXXX , XXXXXXX , XXXXXXX , XXXXXXX , _______ , _______ , _______ , _______ , _______ , KC_PSCR , KC_SLCK , KC_PAUS  , \ */
  /* _______ , KC_F1   , KC_F2   , KC_F3   , KC_F4   , KC_F5   , _______ , XXXXXXX , XXXXXXX , _______ , KC_F6   , KC_F7   , KC_F8   , KC_F9   , KC_F10  , KC_F11  , KC_F12  , _______  , \ */
  /* _______ , _______ , KC_PGUP , KC_UP   , KC_PGDN , KC_HOME , _______ , _______ , _______ , _______ , KC_HOME , KC_PGDN , KC_UP   , KC_PGUP , _______ , KC_INS  , KC_HOME , KC_PGUP  , \ */
  /* _______ , _______ , KC_LEFT , KC_DOWN , KC_RGHT , KC_END  , TG_FUNC , _______ , _______ , _______ , KC_END  , KC_LEFT , KC_DOWN , KC_RGHT , _______ , KC_DEL  , KC_END  , KC_PGDN  , \ */
  /* _______ , XXXXXXX , _______ , _______ , _______ , _______ , XXXXXXX , _______ , TG_FUNC , XXXXXXX , _______ , _______ , XXXXXXX , _______ , XXXXXXX , _______ , XXXXXXX , _______\ */
  /* )       , */
  [_FUNCTION] = LAYOUT( \
  _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______   , \
  _______ , _______ , _______ , _______ , _______ , _______ , XXXXXXX , XXXXXXX , _______ , _______ , _______ , _______ , _______ , _______ , _______ , KC_UP   , KC_RGHT , _______   , \
  _______ , _______ , _______ , _______ , _______ , _______ , _______ , XXXXXXX , XXXXXXX , _______ , _______ , _______ , _______ , _______ , KC_LEFT , KC_DOWN , _______ , _______   , \
  _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______   , \
  _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______   , \
  _______ , XXXXXXX , _______ , _______ , _______ , _______ , XXXXXXX , XXXXXXX , XXXXXXX , XXXXXXX , _______ , _______ , XXXXXXX , _______ , XXXXXXX , _______ , XXXXXXX , _______\
  ), 
  [_TENKEY] = LAYOUT( \
  _______ , _______ , MACRO5  , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , \
  _______ ,CLICK_REV, MACRO1  , MACRO2  , MACRO3  , MACRO4  , XXXXXXX , XXXXXXX , _______ , _______ , KC_NLCK , KC_TAB  , KC_PSLS , KC_PAST , KC_BSPC , _______ , _______ , _______ , \
  _______ , _______ , _______ , _______ , _______ , _______ , _______ , XXXXXXX , XXXXXXX , _______ , _______ , KC_P7   , KC_P8   , KC_P9   , KC_PMNS , _______ , _______ , _______ , \
  _______ , _______ , _______ , KC_UP   , _______ , _______ , _______ , _______ , _______ ,TG_NODOKA, _______ , KC_P4   , KC_P5   , KC_P6   , KC_PPLS , _______ , _______ , _______ , \
  _______ , _______ , KC_LEFT , KC_DOWN , KC_RGHT , _______ , TG_TEN  , KC_BTN3 , MS_D1   , TG_TEN  , _______ , KC_P1   , KC_P2   , KC_P3   , KC_PENT , _______ , _______ , _______   , \
  _______ , XXXXXXX , _______ , _______ , _______ , _______ , XXXXXXX , XXXXXXX , XXXXXXX , XXXXXXX , _______ , KC_P0   , KC_00   , KC_PDOT , XXXXXXX , _______ , XXXXXXX , _______\
  )       ,
  /* [_TEMPLATE] = LAYOUT( \ */
  /* _______ , _______ , XXXXXXX , XXXXXXX , XXXXXXX , XXXXXXX , XXXXXXX , XXXXXXX , XXXXXXX , XXXXXXX , XXXXXXX , XXXXXXX , XXXXXXX , XXXXXXX , _______ , _______ , _______ , _______   , \ */
  /* _______ , _______ , _______ , _______ , _______ , _______ , XXXXXXX , XXXXXXX , XXXXXXX , XXXXXXX , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______   , \ */
  /* _______ , _______ , _______ , _______ , _______ , _______ , _______ , XXXXXXX , XXXXXXX , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______   , \ */
  /* _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______   , \ */
  /* _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______ , _______   , \ */
  /* _______ , XXXXXXX , _______ , _______ , _______ , _______ , XXXXXXX , _______ , _______ , XXXXXXX , _______ , _______ , XXXXXXX , _______ , XXXXXXX , _______ , XXXXXXX , _______\ */
  /* ),  */
};

static bool ms_btn1_is_left = true;
static bool mhen_pressed = false;
static uint16_t mhen_pressed_time = 0;
static bool henk_pressed = false;
static uint16_t henk_pressed_time = 0;
static bool ctl_esc_pressed = false;
static uint16_t ctl_esc_pressed_time = 0;
static bool ctl_app_pressed = false;
static uint16_t ctl_app_pressed_time = 0;
static bool alt_kana_pressed = false;
static uint16_t alt_kana_pressed_time = 0;
static bool sft_spc_pressed = false;
static uint16_t sft_spc_pressed_time = 0;
static bool tt_tenkey_pressed = false;
static uint16_t tt_tenkey_pressed_time = 0;
static bool tt_func_pressed = false;
static uint16_t tt_func_pressed_time = 0;
static bool is_alt_tab_active = false;
static bool is_lctl_active = false;
static uint16_t alt_tab_timer = 0;

// user_lt(record, ホールド時移行先レイヤー, タップ時のキーコード, モディファイアキー押下判定のための変数, trueならTAPPING_TERMより長押ししたときにタップと判定する)
static void user_lt(keyrecord_t *record, int layer, uint16_t keycode, bool *modifier_pressed, uint16_t *modifier_pressed_time, bool tapping_term_disable) {
        if (record->event.pressed) {
        *modifier_pressed = true;
        *modifier_pressed_time = record->event.time;

        layer_on(layer);
      } else {
        layer_off(layer);

        if (*modifier_pressed && (tapping_term_disable || (timer_elapsed(*modifier_pressed_time) < TAPPING_TERM))) {
          register_code(keycode);
          unregister_code(keycode);
        }
        *modifier_pressed = false;
      }
}

// user_lt(record, ホールド時キーコードー, タップ時のキーコード, モディファイアキー押下判定のための変数, trueならTAPPING_TERMより長押ししたときにタップと判定する)
static void user_mt(keyrecord_t *record, uint16_t modcode, uint16_t keycode, bool *modifier_pressed, uint16_t *modifier_pressed_time, bool tapping_term_disable) {
        if (record->event.pressed) {
        *modifier_pressed = true;
        *modifier_pressed_time = record->event.time;
      } else {
	if (!*modifier_pressed) unregister_code(modcode);
        if (*modifier_pressed && (tapping_term_disable || (timer_elapsed(*modifier_pressed_time) < TAPPING_TERM))) {
          register_code(keycode);
          unregister_code(keycode);
        }
        *modifier_pressed = false;
      }
}

// user_ft(record, ホールド時移行先レイヤー, タップ時の移行レイヤー, モディファイアキー押下判定のための変数, trueならTAPPING_TERMより長押ししたときにタップと判定する)
static void user_tt(keyrecord_t *record, int layer, int tap_layer, bool *modifier_pressed, uint16_t *modifier_pressed_time, bool tapping_term_disable) {
        if (record->event.pressed) {
        *modifier_pressed = true;
        *modifier_pressed_time = record->event.time;

        layer_on(layer);
      } else {
        layer_off(layer);

        if (*modifier_pressed && (tapping_term_disable || (timer_elapsed(*modifier_pressed_time) < TAPPING_TERM))) {
          layer_on(tap_layer);
        }
        *modifier_pressed = false;
      }
}


bool process_record_user(uint16_t keycode, keyrecord_t *record) {
  switch (keycode) {
    case LT2_MHEN:
      user_lt(record, _HENKAN, KC_ENT, &mhen_pressed, &mhen_pressed_time, true);
      return false;
      break;
    case LT2_HENK:
      user_lt(record, _HENKAN, KC_HENK, &henk_pressed, &henk_pressed_time, true);
      return false;
      break;
    case TT_TEN:
      user_tt(record, _TENKEY, _TENKEY, &tt_tenkey_pressed, &tt_tenkey_pressed_time, true);
      return false;
      break;
    case TT_FUNC:
      user_tt(record, _FUNCTION, _FUNCTION, &tt_func_pressed, &tt_func_pressed_time, true);
      return false;
      break;
    case CTL_ESC:
      user_mt(record, KC_LCTL, KC_ESC, &ctl_esc_pressed, &ctl_esc_pressed_time, true);
      if (!record->event.pressed) is_lctl_active = false;
      return false;
      break;
    case CTL_APP:
      user_mt(record, KC_RCTL, KC_APP, &ctl_app_pressed, &ctl_app_pressed_time, true);
      return false;
      break;
    case ALT_KANA:
      user_mt(record, KC_RALT, KC_KANA, &alt_kana_pressed, &alt_kana_pressed_time, true);
      return false;
      break;
    case SFT_SPC:
      user_mt(record, KC_LSFT, KC_SPC, &sft_spc_pressed, &sft_spc_pressed_time, true);
      return false;
      break;
    default:
      if (record->event.pressed) {
        // reset the user_lt flags
        mhen_pressed = false;
        henk_pressed = false;
        tt_tenkey_pressed = false;
        tt_func_pressed = false;

	// operate user_mt flags
        if (ctl_esc_pressed) {register_code(KC_LCTL); is_lctl_active = true;}
        ctl_esc_pressed  = false;
        if (ctl_app_pressed) register_code(KC_RCTL);
        ctl_app_pressed = false;
        if (sft_spc_pressed) register_code(KC_LSFT);
        sft_spc_pressed  = false;
        if (alt_kana_pressed) register_code(KC_RALT);
        alt_kana_pressed = false;
      }
      switch (keycode) {  // usr_lt, mtと併用したいキーはこちらで定義
        case KC_I: // LCTL + I = TAB
          if (record->event.pressed) {
            if (is_lctl_active && layer_state_is(_NODOKA)) {
              unregister_code(KC_LCTL);
              register_code(KC_TAB);
              register_code(KC_LCTL);
            } else {
              register_code(KC_I);
            }
          } else {
            if (is_lctl_active && layer_state_is(_NODOKA)) {
              unregister_code(KC_TAB);
            } else {
              unregister_code(KC_I);
            }
          }
          return false;
          break;
        case ALT_F4:
          if (record->event.pressed) {
            register_code16(A(KC_F4));
          } else {
            unregister_code16(A(KC_F4));
          }
          return false;
          break;
        case C_S_ESP:
          if (record->event.pressed) {
            register_code16(S(C(KC_ESC)));
          }
          return false;
          break;
        case MACRO1:
          if (record->event.pressed) {
            SEND_STRING(MACRO1_STRINGS);
	        ms_btn1_is_left = false;
          }
          return false;
          break;
        case MACRO2:
          if (record->event.pressed) {
            SEND_STRING(MACRO2_STRINGS);
	        ms_btn1_is_left = false;
          }
          return false;
          break;
        case MACRO3:
          if (record->event.pressed) {
             SEND_STRING(MACRO3_STRINGS);
          }
          return false;
          break;
        case MACRO4:
          if (record->event.pressed) {
            SEND_STRING(MACRO4_STRINGS);
	        ms_btn1_is_left = true;
          }
          return false;
        case MACRO5:
          if (record->event.pressed) {
             SEND_STRING(MACRO5_STRINGS);
          }
          return false;
          break;
        case CLICK_REV:
          if (record->event.pressed) {
            if (ms_btn1_is_left) {
	          ms_btn1_is_left = false;
            } else {
	          ms_btn1_is_left = true;
	        }
          }
          return false;
          break;
        case MS_BTN1:
          if (record->event.pressed) {
            if (ms_btn1_is_left) {
	          register_code(KC_BTN1);
            } else {
	          register_code(KC_BTN2);
	        }
          } else {
            if (ms_btn1_is_left) {
	          unregister_code(KC_BTN1);
            } else {
	          unregister_code(KC_BTN2);
	        }
	      }
          return false;
          break;
        case MS_BTN2:
          if (record->event.pressed) {
            if (!ms_btn1_is_left) {
	          register_code(KC_BTN1);
            } else {
	          register_code(KC_BTN2);
	        }
          } else {
            if (!ms_btn1_is_left) {
	          unregister_code(KC_BTN1);
            } else {
	          unregister_code(KC_BTN2);
	        }
	      }
          return false;
          break;
        case MS_D1:
          if (record->event.pressed) {
          } else {
	        register_code(KC_BTN1);
	        unregister_code(KC_BTN1);
	        register_code(KC_BTN1);
	        unregister_code(KC_BTN1);
	      }
          return false;
          break;
      	case NEXTWIN: // ALT+TAB
          if (record->event.pressed) {
            if (!is_alt_tab_active) {
              is_alt_tab_active = true;
              register_code(KC_LALT);
            }
            alt_tab_timer = timer_read();
            register_code(KC_TAB);
          } else {
            unregister_code(KC_TAB);
          }
          break;
      	case KC_00: // ALT+TAB
          if (record->event.pressed) {
             SEND_STRING("00");
          }
	  return false;
          break;
        /* case PREVWIN: // ALT+SHIFT+TAB */
        /*   if (record->event.pressed) { */
        /*     if (!is_alt_tab_active) { */
        /*       is_alt_tab_active = true; */
        /*       register_code(KC_LALT); */
        /*     } */
        /*     alt_tab_timer = timer_read(); */
        /*     register_code16(S(KC_TAB)); */
        /*   } else { */
        /*     unregister_code16(S(KC_TAB)); */
        /*   } */
        /*   break; */
      }
  }
  return true;
}

void matrix_init_user(void) {
// Pro MicroのLEDを使用する準備
  setPinOutput(D5);
  setPinOutput(B0);
}

// 定期実行される関数
void matrix_scan_user(void) {
   // Alt + tab用
  if (is_alt_tab_active) {
    if (timer_elapsed(alt_tab_timer) > 400) {
      unregister_code(KC_LALT);
      is_alt_tab_active = false;
    }
  }
   // TAPPING_TERM以降はモディファイアキーを押下
  if (ctl_esc_pressed && timer_elapsed(ctl_esc_pressed_time) > TAPPING_TERM) {register_code(KC_LCTL); is_lctl_active = true; ctl_esc_pressed = false;}
  if (ctl_app_pressed && timer_elapsed(ctl_app_pressed_time) > TAPPING_TERM) {register_code(KC_RCTL); ctl_app_pressed  = false;}
  if (alt_kana_pressed && timer_elapsed(alt_kana_pressed_time) > TAPPING_TERM) {register_code(KC_RALT); alt_kana_pressed = false;}
  if (sft_spc_pressed && timer_elapsed(sft_spc_pressed_time) > TAPPING_TERM) {register_code(KC_LSFT); sft_spc_pressed  = false;}

  // Pro micro 本体のLEDによるインディケータ
  if (!layer_state_is(_FUNCTION) && !layer_state_is(_TENKEY)) {
    //  _Functionと_TENKEYのどちらも無効な場合 _QWERYと_NODOKAの状態を表示
    //Left LED 11
    if (layer_state_is(_NODOKA)) {
      // LED 11
      writePinLow(D5);
      writePinLow(B0);
    } else {
      // LED 00
      writePinHigh(D5);
      writePinHigh(B0);
    }
  } else {
    if (layer_state_is(_FUNCTION)) {
      //Left LED 1X
      writePinLow(D5);
    } else {
      // LED 0X
      writePinHigh(D5);
    }
    if (layer_state_is(_TENKEY)) {
      //Left LED X1
      writePinLow(B0);
    } else {
      // LED X1
      writePinHigh(B0);
    }
  }
}


